/*
 *	G	XgbvEHb`
 *
 *		gp{[h
 *			ADM-001: PIC 16F627A
 *			ADM-203: 7SEGMENT LED
 *			ADM-101: PUSH SWITCH
 *
 *		ڑ
 *			ADM-001				ADM-203
 *			RB0					P4
 *			RB1					P3
 *			RB2					P2
 *			RB3					P1
 *			RB4					P5
 *			RB5					P6
 *			RB6					P7
 *			RB7					P8
 *
 *			ADM-001				ADM-101
 *			RA0					P1
 *			RA1					P2
 *			RA2					P3
 *
 *							2009N1001
 */


/*
	CN[h
 */
#include <pic.h>


/*
	RtBM[V[h̐ݒ
 */
//__CONFIG ( CP_OFF & LVP_OFF & BOREN_ON & MCLRE_ON & PWRTE_ON & WDTE_OFF & FOSC_INTOSCIO );
#pragma config CPD=OFF , LVP=OFF , BOREN=ON , MCLRE=ON , PWRTE=ON , WDTE=OFF , FOSC=INTOSCIO

/*
	vg^Cv錾
 */
void set7Seg( unsigned int num, unsigned int id );		// idŎw肵7SEG LEDɐ\
void dispNum( unsigned int num );						// 4̐l\
void waitTime( unsigned int num );						//@҂


/*
	}N`
 */

#define	CCPR1_VAL			1000L		// 1mbƂɊޏꍇCCPR1ɑl

#define	STATE_WAIT_START	0			// START҂
#define	STATE_STOPWATCH		1			// STOP WATCH
#define	STATE_STOP			2			// STOP
	
#define	SW_START			RA0			// START SW
#define	SW_STOP				RA1			// STOP SW
#define	SW_RESET			RA2			// RESET SW
	
#define	SW_ON				0
#define	SW_OFF				1


/*
 	O[oϐ
 */
unsigned long g_ms = 0;			// o mb i[
unsigned int  g_state;			// vOԕϐ



/*
	main
 */
void main( void ){

	/*	|[g	*/	
	CMCON = 0x07;						// RA0`RA3 <- IO
	PORTB = 0x00;						// PORTB    <- Lx
	TRISB = 0x00;						// PORTB    <- outport
	TRISA = 0b00100111;					// RA0`RA2 <- inport
	
	/*	CCPݏ 1msƂɊ	*/
	CCP1CON = 0b00001011;				// CCP݃[h
	CCPR1H = ( CCPR1_VAL >> 8 );		// CCPR1H <- CCPR1_VAL̏8rbg
	CCPR1L = ( CCPR1_VAL & 0x00FF );	// CCPR1L <- CCPR1_VAL̉8rbg
 
	CCP1IF = 0;							// CCP݃tONA
	CCP1IE = 1;							// CCP݂̋

	
	/*	Timer1	*/
	TMR1ON  = 0;						// Timer1 Stop
	TMR1CS  = 0;						// NbNNbNɐݒ
	
	T1CKPS1 = 0;						// /1
	T1CKPS0 = 0;
	
	TMR1H = 0;							// TMRWX^NA
	TMR1L = 0;
	
	/*	݋	*/
	PEIE = 1;							// Ӌ@\݋
	GIE  = 1;							// ݑS̋
	
	g_state = STATE_WAIT_START;			// vOԕϐ <- START҂

	while(1){
		
		// vOԕϐg_stateɂ菈
		switch ( g_state ){

			// START҂
			case STATE_WAIT_START:{
				
				// START SWꂽꍇ
				if( SW_START == SW_ON ){
					TMR1ON = 1;						// Timer1 Start
					g_state = STATE_STOPWATCH;		// "STOPWATCH"ɑJ
				}
				break;
			}
			
			// STOPWATCH
			case STATE_STOPWATCH:{
				
				// STOP SWꂽꍇ
				if( SW_STOP == SW_ON ){

					TMR1ON = 0;						// Timer1 Stop
					g_state = STATE_STOP;			// "STOP"ɑJ
				}
				break;
			}
			
			// STOP
			case STATE_STOP:{

				// RESET SWꂽꍇ
				if( SW_RESET == SW_ON ){

					TMR1H = 0;						// TMRWX^NA
					TMR1L = 0;
					
					g_ms = 0;						// omb
					g_state = STATE_WAIT_START;		// "START҂"ɑJ
				}
				// START SWꂽꍇ
				else if( SW_START == SW_ON ){
					
					TMR1ON = 1;						// Timer1 Start
					g_state = STATE_STOPWATCH;		// "STOPWATCH"ɑJ
				}
				break;
			}
			
		}

		dispNum ( g_ms / 10 );						// omb10mbPʂŕ\
	}
}


/*
	117SEGɐZbg

	
		num : Zbg鐔 ( l )
		id  : 0 -> 4
		      1 -> 3
		      2 -> 2
		      3 -> 1
*/
void set7Seg( unsigned int num, unsigned int id ){

	PORTB = ( ( 0b00001000 >> id ) | ( num << 4 ) );
}

/*
	4̐l\

	
		num : \鐔l
 */
void dispNum( unsigned int num ){

	set7Seg( num / 1000 % 10, 0 );		// 4ڕ\
	waitTime(120);
	set7Seg( num / 100  % 10, 1 );		// 3ڕ\
	waitTime(110);
	set7Seg( num / 10   % 10, 2 );		// 2ڕ\
	waitTime(100);
	set7Seg( num / 1    % 10, 3 );		// 1ڕ\

}

//@҂
void waitTime( unsigned int num ){
	while(num > 0)
	num--;
}

/*
	݃T[rX[`
		1mbƂCCP
 */
static void __interrupt() isr(void){

	// 99990mbo߂StopWatch~
	if( g_ms > 99990 ){
		TMR1ON = 0;						// Timer1 Stop
		g_state = STATE_STOP;			// "STOP"ɑJ
	}
	else{
		g_ms++;							// omb + 1
		CCP1IF = 0;						// CCP݃tONA
	}

}