/*
 *	G	Xbg
 *
 *		gp{[h
 *			ADM-001: PIC 16F627A
 *			ADM-203: 7SEGMENT LED
 *			ADM-101: PUSH SWITCH
 *			ADM-103: TOGGLE SWITCH
 *
 *		ڑ
 *			ADM-001				ADM-203
 *			RB0					P4
 *			RB1					P3
 *			RB2					P2
 *			RB3					P1
 *			RB4					P5
 *			RB5					P6
 *			RB6					P7
 *			RB7					P8
 *
 *			ADM-001				ADM-101
 *			RA0					P1
 *			RA1					P2
 *			RA2					P3
 *			RA3					P4
 *
 *			ADM-001				ADM-103
 *			RA7					P1
 *
 *							2009N1001
 *
 */


/*
	CN[h
 */
#include <pic.h>


/*
	RtBM[V[h̐ݒ
 */
//__CONFIG ( CP_OFF & LVP_OFF & BOREN_ON & MCLRE_ON & PWRTE_ON & WDTE_OFF & FOSC_INTOSCIO );
#pragma config CPD=OFF , LVP=OFF , BOREN=ON , MCLRE=ON , PWRTE=ON , WDTE=OFF , FOSC=INTOSCIO

/*
	vg^Cv錾
 */
void set7Seg( unsigned int num, unsigned int id );		// idŎw肵7SEG LEDɐ\
void dispSlot( void );									// \
int  isAllSlotStop( void );								// ׂĂSLOT~mF

/*
	}N`
 */
#define	CCPR1_VAL			50000L	// 50mbƂɊޏꍇCCPR1ɑl
#define	STATE_WAIT_START	0		// START҂
#define	STATE_SLOT			1		// SLOT
#define	STATE_STOP			2		// STOP
	
#define	SW_SLOT1			RA0		// SLOT1 STOPp SW
#define	SW_SLOT2			RA1		// SLOT2 STOPp SW
#define	SW_SLOT3			RA2		// SLOT3 STOPp SW
#define	SW_SLOT4			RA3		// SLOT4 STOPp SW

#define	TS_START			RA7		// STARTp TOGGLE SW

#define	SLOT_CNT			4		// SLOT̐
#define	SLOT_TURN			0		// SLOT]
#define	SLOT_STOP			1		// SLOT~

#define	SW_ON				0
#define	SW_OFF				1



/*
 	O[oϐ
 */
unsigned int a_slot[SLOT_CNT];				// SLOTɕ\l
unsigned int a_stopSlot[SLOT_CNT];			// SLOT~tO
unsigned int g_state;						// vOԕϐ


/*
	main
 */
void main( void ){

	int i, flg;

	/*	|[g	*/	
	CMCON = 0x07;						// RA0`RA3     <- IO
	PORTB = 0x00;						// PORTB        <- Lx
	TRISB = 0x00;						// PORTB        <- outport
	TRISA = 0b10101111;					// RA7,RA0`RA3 <- inport

	/*	CCPݏ 50mbƂɊ	*/
	CCP1CON = 0b00001011;				// CCP݃[h
	CCPR1H  = ( CCPR1_VAL >> 8 );		// CCPR1H <- CCPR1_VAL̏8rbg
	CCPR1L  = ( CCPR1_VAL & 0x00FF );	// CCPR1L <- CCPR1_VAL̉8rbg

	CCP1IF  = 0;						// CCP݃tONA
	CCP1IE  = 1;						// CCP݂̋

	
	/*	Timer1	*/
	TMR1ON  = 0;						// Timer1 Stop
	TMR1CS  = 0;						// NbNNbNɐݒ
	
	T1CKPS1 = 0;						// /1
	T1CKPS0 = 0;

	TMR1H   = 0;						// TMRWX^NA
	TMR1L   = 0;
	
	/*	݋	*/
	PEIE = 1;							// Ӌ@\݋
	GIE  = 1;							// ݑS̋


	g_state = STATE_WAIT_START;			// vOԕϐ <- START҂

	/*	SLOT̒lCSLOT~tO	*/
	for( i = 0; i < SLOT_CNT; i++ ){
		a_slot[i]     = 0;
		a_stopSlot[i] = SLOT_TURN;
	}


	while(1){

		// vOԕϐg_stateɂ菈
		switch ( g_state ){
			
			// START҂
			case STATE_WAIT_START:{

				// STARTp TOGGLE SWONɂȂꍇ
				if(TS_START == SW_ON ){
					TMR1ON  = 1;				// Timer1 Start
					g_state = STATE_SLOT;		// "SLOT"ɑJ
				}

				break;
			}
			// SLOT
			case STATE_SLOT:{
				
				// SLOT STOP SWꂽC~tO𗧂Ă
				if( SW_SLOT1 == SW_ON )	{	a_stopSlot[0] = SLOT_STOP;	}
				if( SW_SLOT2 == SW_ON )	{	a_stopSlot[1] = SLOT_STOP;	}
				if( SW_SLOT3 == SW_ON )	{	a_stopSlot[2] = SLOT_STOP;	}
				if( SW_SLOT4 == SW_ON )	{	a_stopSlot[3] = SLOT_STOP;	}

				//	ׂĂSLOT~Ăꍇ
				if ( isAllSlotStop() ){
					TMR1ON = 0;					// Timer1 Stop
					g_state = STATE_STOP;		// "STOP"ɑJ
				}
				
				
				/*
					]STARTp TOGGLE SWOFFɂꍇZbgȂǂ
					ǉꍇɂ́CɋLq
				*/

				break;
			
			}
			
			// STOP
			case STATE_STOP:{
				
				// STARTp TOGGLE SWOFFɂȂꍇ
				if(TS_START == SW_OFF ){

					/*	SLOT̒lCSLOT~tO	*/
					for( i = 0; i <  SLOT_CNT; i++ ){
						a_slot[i]     = 0;
						a_stopSlot[i] = SLOT_TURN;
					}

					g_state = STATE_WAIT_START;
				}
				break;
			}

		}

		dispSlot( );	// SLOT̕\
	}
}





/*
	117SEGɐZbg

	
		num : Zbg鐔 ( l )
		id  : 0 -> SLOT1
		      1 -> SLOT2
		      2 -> SLOT3
		      3 -> SLOT4
*/
void set7Seg( unsigned int num, unsigned int id ){

	PORTB = ( ( 0b00001000 >> id ) | ( num << 4 ) );
}	

/*
	Xbgɐl\
 */
void dispSlot( void ){

	int i;

	// 7SEGMENT LEDa_slot̐ɕ\
	for( i = 0; i < SLOT_CNT; i++ ){
		set7Seg( a_slot[i], ( SLOT_CNT - ( i + 1 ) ) );
	}
	
}

/*
	ׂĂSLOT~mF
	߂l
		1 : ׂĒ~
		0 : 1ȏ]
 */
int  isAllSlotStop( void ){
	
	int i;
	
	for ( i = 0; i < SLOT_CNT; i++ ){
		// ]SLOTꍇ
		if ( a_stopSlot[i] == SLOT_TURN ){
			return ( 0 );			// ߂lF0
		}
	}
	
	// ׂĂSLOT~
	return ( 1 );					// ߂lF1

}

/*
	݃T[rX[`
		50mbƂCCP
		
		SLOTƂɉ]xςꍇɂ́C
		̊֐ɏǉ
 */
static void __interrupt() isr(void){

	int i;

	// SLOT]
	for( i = 0; i < SLOT_CNT; i++ ){

		// SLOT]
		if ( a_stopSlot[i] == SLOT_TURN ){

			a_slot[i]++;			// SLOT̒l + 1

			if ( a_slot[i] > 9 ){
				a_slot[i] = 0;		// 10̏ꍇ 0 ɖ߂
			}
		}
	}
	
	CCP1IF = 0;						// CCP݃tONA
}


