/*
 *	G	ZK
 *
 *		gp{[h
 *			ADM-001: PIC 16F627A
 *			ADM-104: JOYSTICK SWITCH
 *			ADM-202: LCD 16~2
 *
 *		ڑ
 *			ADM-001			ADM-202
 *			RA0				D4
 *			RA1				D5
 *			RA2				D6
 *			RA3				D7
 *			RA6				E
 *			RA7				RS
 *
 *			ADM-001			ADM-104
 *			RB3				RIGHT1
 *			RB4				LEFT1
 *			RB5				CENTER1
 *			RB6				UP1
 *			RB7				DOWN1
 *
 *							2009N1001
 */


/*
	CN[h
 */
#include <pic.h>


/*
	RtBM[V[h̐ݒ
 */
//__CONFIG ( CP_OFF & LVP_OFF & BOREN_ON & MCLRE_ON & PWRTE_ON & WDTE_OFF & FOSC_INTOSCIO );
#pragma config CPD=OFF , LVP=OFF , BOREN=ON , MCLRE=ON , PWRTE=ON , WDTE=OFF , FOSC=INTOSCIO

/*
	vg^Cv錾
 */
void lcd_init ( void );						// LCD֐
void lcd_write (unsigned char data );		// LCDR}h͊֐
void lcd_disp ( char* s );					// LCD\֐
void lcd_clear ( void )	;					// LCDNA֐
void lcd_pos ( unsigned char pos);			// LCDJ[\ύX֐
void DelayMs ( unsigned char ms );		// ҂Ԋ֐iPʁFmsj


/*
	}N`
 */
#define		LCD_RS			RA7
#define		LCD_TOGGLE_E	RA6=1,RA6=0	// LCD̃R}hLgK
#define		JS_RIGHT		RB3
#define		JS_LEFT			RB4
#define		JS_CENTER		RB5
#define		JS_UP			RB6
#define		JS_DOWN			RB7
#define		SW_ON			0			// ANeBu L
#define		SW_OFF			1			// ANeBu L
#define		MAX_QST			4			// 萔


/*
 	O[oϐ
 */
unsigned char g_cnt = 0;	// ҂ԗp


/*
 	萔
 */

// z񉻁FvfύX邱ƂŖύX
const unsigned char a_qst[MAX_QST][7] = { "18+36=" , " 3* 4=" ,"55-20=" , "50+50="};

// z񉻁Fa_qstƑΉC킹Ń[U𓚂Ɣr
const unsigned int a_ans[MAX_QST] = { 54       , 12       ,35       , 100     };

// Iz񉻁FI̕\⃆[U𓚂̕\Ŏgp
const unsigned char a_select[10][2] = { "0","1","2","3","4","5","6","7","8","9" };



/*
 	main֐
 */
void main( void ){
	
	unsigned char select_pos = 0x40;	// ĨJ[\ʒui[
	unsigned char ans_pos	 = 0x06;	// [U𓚂\J[\ʒui[
	unsigned int  ans		 = 0;		// [U𓚂i[
	unsigned char qst_num	 = 0;		// a_probCa_ans̓Yp
	
	
	/* |[g */
	CMCON = 0b00000111;		// RA0`3o͒[qɐݒ
	TRISA = 0b00100000;		// RA5ȊOo͒[qɐݒiڑ{[hFLCDj
	TRISB = 0b11111000;		// RB3`7͒[qɐݒiڑ{[hFJOYSTICKj
	PORTA = 0;				// PORTA̓dx
	PORTB = 0;				// PORTB̓dx
	
	
	/* ݋ */
	PEIE = 1;		// Ӌ@\݂̋
	GIE	 = 1;		// ݑŜ̋
	
	
	/* ^C}1ݏ 16rbg^C} 1usecƂɃJEg */
	TMR1CS  = 0;			// NbN̐ݒ		FNbN
	T1CKPS1 = 0;			// vXP[̐ݒ	F/1
	T1CKPS0 = 0;
	TMR1L   = 0b00010111;	// TMR1WX^NA
	TMR1H   = 0b11111100;
	TMR1IF  = 0;			// ^C}1݃tONA
	TMR1IE  = 1;			// ^C}1݂
	TMR1ON  = 0;			// ^C}1~
	
	
	/* LCD̏ */
	lcd_init();
	lcd_clear();
	
	
	/* Jn */
	lcd_disp( "START" );
	DelayMs( 200 );
	DelayMs( 200 );
	DelayMs( 200 );
	DelayMs( 200 );
	DelayMs( 200 );
	lcd_clear();
	
	
	// SI܂Ń[v
	for( qst_num = 0; qst_num < MAX_QST; qst_num++ ){
		
		/* \ */
		lcd_pos ( 0x00 );				// J[\ړ
		lcd_disp( &a_qst[qst_num] );	// \
		
		/* I\ */
		lcd_pos( select_pos );			// J[\ړ
		lcd_disp( "0123456789" );		// I\
		lcd_pos( select_pos );			// J[\0̈ʒuɈړ
		
		
		// JS_CENTEROFF̊ԁC[U𓚂
		while( JS_CENTER == SW_OFF ){
			
			// JS_RIGHTONŁCJ[\EVtg
			if( JS_RIGHT == SW_ON ){
				
				DelayMs(200);	// `^O΍
				
				// select_pos̒lύX
				if( select_pos >= 0x49 )	{	select_pos = 0x40;	}	// E[ł΍[
				else						{	select_pos++;		}	// łȂΉE1Vtg
				
				lcd_pos( select_pos );		// ύX̃J[\ʒuLCDɔf
			}
			
			// JS_LEFTONŁCJ[\Vtg
			if( JS_LEFT == SW_ON ){
				
				DelayMs(200);	// `^O΍
				
				// select_pos̒lύX
				if( select_pos <= 0x40 )	{	select_pos = 0x49;	}	// [łΉE[
				else						{	select_pos--;		}	// łȂ΍1Vtg
				
				lcd_pos( select_pos );		// ύX̃J[\ʒuLCDɔf
			}
			
			// JS_UPONŁCI[U𓚂ɔf
			if( JS_UP == SW_ON ){
				
				DelayMs(200);	// `^O΍
				
				/* I̕\ */
				lcd_pos( ans_pos );								// J[\ړ
				lcd_disp( &a_select[ ( select_pos & 0x0f ) ] );	// select_posIĂ鐔o\
				
				/* Iansɔf */
				if ( ans_pos != 0x06 )	{	ans *= 10;	}	// 2ȏɂȂ10{
				ans += (select_pos & 0x0f );				// Z
				
				ans_pos++;							// [U𓚂̕\ʒuEVtg
				
				lcd_pos( select_pos );				// J[\ʒu߂
			}
			
			// JS_DOWNONŁC[U𓚂NA
			if( JS_DOWN == SW_ON ){
				
				DelayMs(50);	// `^O΍
				
				ans = 0;						// [U𓚂NA
				
				ans_pos = 0x06;					// [U𓚂̃J[\ʒu
				
				/* 󔒂\C[U𓚂̕\NA */
				lcd_pos ( ans_pos );
				lcd_disp ( "           " );
				
				lcd_pos( select_pos );			// J[\ʒu߂
			}
		}
		
		/* 킹 */
		lcd_clear();		// LCD̕\NA
		
		// [U𓚂Ɛr
		if( ans == a_ans[qst_num] )	{	lcd_disp( "correct" );	}	// correct\
		else						{	lcd_disp( "mistake" );	}	// smistake\
		
		DelayMs( 200 );
		DelayMs( 200 );
		DelayMs( 200 );
		DelayMs( 200 );
		DelayMs( 200 );
		
		
		/* C̖ */
		ans = 0;
		select_pos = 0x40;
		ans_pos = 0x06;
		lcd_clear();
	}
	
	/* I */
	lcd_clear();
	lcd_disp( "FINISH" );
	
	while(1)
		;
}	


/*
	҂Ԋ֐iPʁFmsj
		F҂Ԃ̒limsj
 */
void DelayMs( unsigned char ms ){
	
	g_cnt = ms;
	
	TMR1ON = 1;			// ^C}1N
	
	// g_cnt0菬Ȃ܂Ń[vi݃[`g_cntfNgj
	while ( g_cnt > 0 )
		;
	
	TMR1ON = 0;			// ^C}1~
}


/*
	݃T[rX[`
		ݗvF^C}1
 */
static void __interrupt() isr(void){
	
	g_cnt--;				// g_cntfNg
	TMR1IF = 0;				// ^C}1݃tONA
	TMR1L = 0b00010111;		// ^C}1NA
	TMR1H = 0b11111100;		
}


/*
	LCDɃR}h̓f[^𑗂֐
		FR}h́Cf[^
 */
void lcd_write( unsigned char data ){
	
	PORTA = ( (LCD_RS << 7) + (data >> 4) );	// 4rbg]
	LCD_TOGGLE_E;
	PORTA = ( (LCD_RS << 7) + (data & 0x0F) );	// 4rbg]
	LCD_TOGGLE_E;
}


/*
	lcd_writeɕ\f[^n֐
		F\f[^ij
 */
void lcd_disp( char* s ){
	
	LCD_RS = 1;
	
	while ( *s ){
		lcd_write(*s++);
	}
	
	DelayMs(1);
}


/*
	lcd_writeɃNAR}hn֐
 */
void lcd_clear( void ){
	
	LCD_RS = 0;
	lcd_write(1);
	DelayMs(2);
}


/*
	lcd_writeɃJ[\ʒuf[^n֐
		FJ[\ʒuf[^
 */
void lcd_pos( unsigned char pos ){
	LCD_RS = 0;
	lcd_write(0x80 + pos);
}



/*
	lcd̏֐
 */
void lcd_init( void ){
	LCD_RS = 0;		// comand mode
	
	DelayMs( 15 );	// wait 15ms
	
	PORTA = 0x03;
	LCD_TOGGLE_E;
	DelayMs( 5 );	// wait 4.1ms
	
	PORTA = 0x03;
	LCD_TOGGLE_E;
	DelayMs( 1 );	// wait 100us
	
	PORTA = 0x03;
	LCD_TOGGLE_E;
	DelayMs( 5 );	// wait 4.1ms	
	
	PORTA = 0x02;
	LCD_TOGGLE_E;
	DelayMs( 1 );	// wait 40us	4rbgoXɐݒ
	
	PORTA = 0x02;	
	LCD_TOGGLE_E;
	PORTA = 0x08;
	LCD_TOGGLE_E;
	DelayMs( 1 );	// wait 40us	4rbgoXɐݒ肵C2\
	
	PORTA = 0x00;
	LCD_TOGGLE_E;
	PORTA = 0x08;
	LCD_TOGGLE_E;
	DelayMs( 1 );	// wait 40us	\ȂCJ[\ȂCuNȂ
	
	PORTA = 0x00;
	LCD_TOGGLE_E;
	PORTA = 0x0e;
	LCD_TOGGLE_E;
	DelayMs( 1 );	// wait 40us	\CJ[\CuN
	
	PORTA = 0x00;
	LCD_TOGGLE_E;
	PORTA = 0x06;
	LCD_TOGGLE_E;
	DelayMs( 1 );	// wait 40us	AC+1
}
